<?php

	$buf = '';
	$header = Yii::t('Reports','Параметры отчёта,');
	if ($model->clientNumber != '')
	{
		$header .= Yii::t('Reports','Номер покупателя: ').($model->clientNumber).',';
	}
	else
	{
		$header .= Yii::t('Reports','Покупатели все,');
	}
	
	if ('' != $model->dateFrom)
	{
		$header .= Yii::t('Reports','Дата с: ').Yii::app()->dateFormatter->format('dd.MM.yyyy HH.mm.ss',$model->dateFrom).' ';
		if ('' != $model->dateTo)
		{
			$header .= Yii::t('Reports','Дата по: ').Yii::app()->dateFormatter->format('dd.MM.yyyy HH.mm.ss',$model->dateTo).' ';
		}
		else
		{
			$header .= ",";
		}
	}
	elseif ('' != $model->dateTo)
	{
		$header .= Yii::t('Reports','Дата по: ').Yii::app()->dateFormatter->format('dd.MM.yyyy HH.mm.ss',$model->dateTo).' ';
	}

	$header .= Yii::t('Reports','Сортировать по: ');

	if ($model->sortBy == 'date')
	{
		$header .= Yii::t('Reports','дате покупки,');
	}
    elseif ($model->sortBy == 'storeId')
	{
   		$header .= Yii::t('Reports','номеру магазина,');
	}
   	elseif ($model->sortBy == 'itemName' && $model->detailsBy == 'items')
	{
   		$header .= Yii::t('Reports','наименованию товара,');
	}
   	else
	{
   		$header .= Yii::t('Reports','дате покупки,');
	}

	$header .= Yii::t('Reports','Детализировать по: ');

	$discount_list = ClientPurchases::getDiscountList();
	
	if ($model->detailsBy == 'items')
	{
		$header.= Yii::t('Reports','товарам');
	}
	else
	{
		$header .= Yii::t('Reports','чекам,');
		$header .= Yii::t('Reports','Тип скидки: ');
	
		if ($model->discountType == 'all')
		{
			$header.= Yii::t('Reports','все');
		}
		else
		{
			foreach ($discount_list as $scheme)
			{
				foreach ($scheme as $adv)
				{
					foreach ($adv as $id => $name)
					{
						if ($model->discountType == $id)
						{
							$header.= $name;
							break;
						}
					}
				}
			}
		}
	}

	$header .= Yii::t('Reports'," \nНомер магазина,Номер чека,Дата создания,");

	if ($model->clientNumber == '')
	{
		$header .= Yii::t('Reports','Фамилия покупателя,Номер покупателя,Карта покупателя,');
	}

	if ($model->detailsBy == 'items')
	{
		$header .= Yii::t('Reports',"Наименование,Цена,Количество,Сумма\n");

		$mes['header'] = $header;
		$mes['total_str'] = Yii::t('Reports','Подытог(без учета скидок)');
		$mes['total_all_str'] = Yii::t('Reports','Итого(без учета скидок)');

		
		$buf = $mes['header'];
		
		foreach ($data['current_items']  as  $key=>$val)
		{
			$buf .= $val['cashline_id'].'#'.$val['receipt_number'].'#'.$val['receipt_date'].'#';
			if ($model->clientNumber == '')
			{
				$buf .= $val['sur_name'].'#'.$val['client'].'#'.$val['card'].'#';
            }
			
            $price = Yii::app()->numberFormatter->formatCurrency($val['price'], ''); 
            $quantity = Yii::app()->numberFormatter->formatCurrency($val['quantity'], '');
            $total = Yii::app()->numberFormatter->formatCurrency($val['total'], '');            
            
			$buf .= $val['name'].'#'.str_replace("#",".",$price).'#'.str_replace("#",".",$quantity).'#'.str_replace("#",".",$total)."\n";
		}
		
		$buf .= $mes['total_str'].",,,,,";
		if ($model->clientNumber == '')
		{
			$buf .= ",,,";
        }
		
		$quantity = Yii::app()->numberFormatter->formatCurrency($data['subtotal']['total_quantity'], '');
		$total =  Yii::app()->numberFormatter->formatCurrency($data['subtotal']['total'], '');
		
		$buf .= str_replace("#",".",$quantity)."#".str_replace("#",".",$total)."\n";
		$buf .= $mes['total_all_str'] .",,,,,";
		if ($model->clientNumber == '')
		{
			$buf .= ",,,";
        }
		
		$quantity = Yii::app()->numberFormatter->formatCurrency($data['total']['total_quantity'], '');
		$total =  Yii::app()->numberFormatter->formatCurrency($data['total']['total'], '');		
		
		$buf .= str_replace("#",".",$quantity)."#".str_replace("#",".",$total)."\n";
	}
	else
	{
		$buf = $header;
		
		$buf .= Yii::t('Reports',"Процент скидки,Сумма скидки,Сумма чека\n");

		$mes['header'] = $buf;
		$mes['total_str'] = Yii::t('Reports',"Подытог");
		$mes['total_all_str'] = Yii::t('Reports',"Итого");

		foreach ($mes  as  $key=>$value)
		{
			$model->encode($value);
		}
		
		$buf = $mes['header'];

		foreach ($data['current_items']  as  $key=>$val)
		{
			$buf .= $val['cashline_id'].'#'.$val['receipt_number'].'#'.$val['receipt_date'].'#';
			if ($model->clientNumber == '')
			{
				$buf .= $val['sur_name'].'#'.$val['client'].'#'.$val['card'].'#';
			}
			
            $receipt_discount_prc = Yii::app()->numberFormatter->formatCurrency($val['receipt_discount_prc'], ''); 
            $receipt_discount = Yii::app()->numberFormatter->formatCurrency($val['receipt_discount'], '');
            $receipt_amount = Yii::app()->numberFormatter->formatCurrency($val['receipt_amount'], '');
            
			$buf .= str_replace("#",".",$receipt_discount_prc)."#".str_replace("#",".",$receipt_discount)."#".str_replace("#",".",$receipt_amount)."\n";
		}
		
		$buf .= $mes['total_str'].",,,,";
		if ($model->clientNumber == '')
		{
			$buf .= ",,,";
		}
		
        $total_discount = Yii::app()->numberFormatter->formatCurrency($data['subtotal']['total_discount'], '');
        $total =  Yii::app()->numberFormatter->formatCurrency($data['subtotal']['total'], '');
        
		$buf .= str_replace("#",".",$total_discount)."#".str_replace("#",".",$total)."\n";
		$buf .= $mes['total_all_str']." ,,,,";
		
		if ($model->clientNumber == '')
		{
			$buf .= ",,,";
		}
        
        $total_discount = Yii::app()->numberFormatter->formatCurrency($data['total']['total_discount'], '');
        $total =  Yii::app()->numberFormatter->formatCurrency($data['total']['total'], '');     
        
        $buf .= str_replace("#",".",$total_discount)."#".str_replace("#",".",$total)."\n";        
	}
	
	$model->encode($buf);
	
	$len = strlen($buf);
    header("Content-type: application/csv");
	header("Content-Disposition: inline; filename=\"credcardlog.csv\"; size=$len" );
	header("Content-Transfer-Encoding: 8bit");
	header("Content-Length: $len");
	header("Content-Description:  Credit card log");
	print $buf;
